Hex Artifact Content

Artifact c37a69bddde2cb9cdc96d3ab7f38d6e77d255453:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 76 65 72 69 66 79 52 65 71 75 69 72 65 64 50   verifyRequiredP
0570: 61 63 6b 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63  ackages() {..loc
0580: 61 6c 20 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e  al pkg pkgdomain
0590: 20 70 6b 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63   pkgversion..loc
05a0: 61 6c 20 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e  al pkgdir pkgcon
05b0: 66 69 67 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a  figdir pkgfound.
05c0: 0a 09 66 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b  ..for pkg in "${
05d0: 72 65 71 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f  require[@]}"; do
05e0: 0a 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a  ...pkgdomain=''.
05f0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a  ..pkgversion=''.
0600: 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 43 46  ..pkgchanges=(CF
0610: 4c 41 47 53 20 4c 44 46 4c 41 47 53 20 50 41 54  LAGS LDFLAGS PAT
0620: 48 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  H PKG_CONFIG_PAT
0630: 48 29 0a 0a 09 09 63 61 73 65 20 22 24 7b 70 6b  H)....case "${pk
0640: 67 7d 22 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09  g}" in....*:*)..
0650: 09 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 24  ...pkgchanges=($
0660: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0670: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 3a 27   cut -f 2 -d ':'
0680: 29 29 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63  )).....pkg="$(ec
0690: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
06a0: 74 20 2d 66 20 31 20 2d 64 20 27 3a 27 29 22 0a  t -f 1 -d ':')".
06b0: 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09  ....;;...esac...
06c0: 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22 20 69  .case "${pkg}" i
06d0: 6e 0a 09 09 09 2a 2f 2a 40 2a 29 0a 09 09 09 09  n....*/*@*).....
06e0: 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68  pkgdomain="$(ech
06f0: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
0700: 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22 0a 09   -f 2 -d '@')"..
0710: 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24  ...pkgversion="$
0720: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0730: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 2f 27   cut -f 2 -d '/'
0740: 20 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27   | cut -f 1 -d '
0750: 40 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  @')".....pkg="$(
0760: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0770: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
0780: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2f 2a 29  ".....;;....*/*)
0790: 0a 09 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d  .....pkgversion=
07a0: 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22  "$(echo "${pkg}"
07b0: 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27   | cut -f 2 -d '
07c0: 2f 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  /')".....pkg="$(
07d0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
07e0: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
07f0: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 40 2a 29  ".....;;....*@*)
0800: 0a 09 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22  .....pkgdomain="
0810: 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20  $(echo "${pkg}" 
0820: 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 40  | cut -f 2 -d '@
0830: 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65  ')".....pkg="$(e
0840: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0850: 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29 22  ut -f 1 -d '@')"
0860: 0a 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a  .....;;...esac..
0870: 09 09 69 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67  ..if [ -z "${pkg
0880: 64 6f 6d 61 69 6e 7d 22 20 5d 3b 20 74 68 65 6e  domain}" ]; then
0890: 0a 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24  ....pkgdomain="$
08a0: 7b 64 6f 6d 61 69 6e 7d 22 0a 09 09 66 69 0a 0a  {domain}"...fi..
08b0: 09 09 70 6b 67 66 6f 75 6e 64 3d 27 30 27 0a 09  ..pkgfound='0'..
08c0: 09 66 6f 72 20 70 6b 67 64 69 72 20 69 6e 20 22  .for pkgdir in "
08d0: 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67  /opt/appfs/${pkg
08e0: 64 6f 6d 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70  domain}/${pkg}/p
08f0: 6c 61 74 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65  latform"/${pkgve
0900: 72 73 69 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a 09 09  rsion:-*}; do...
0910: 09 70 6b 67 63 6f 6e 66 69 67 64 69 72 3d 22 24  .pkgconfigdir="$
0920: 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 2f 70 6b 67  {pkgdir}/lib/pkg
0930: 63 6f 6e 66 69 67 22 0a 0a 09 09 09 69 66 20 5b  config".....if [
0940: 20 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20   -d "${pkgdir}" 
0950: 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b 67 66  ]; then.....pkgf
0960: 6f 75 6e 64 3d 27 31 27 0a 09 09 09 66 69 0a 0a  ound='1'....fi..
0970: 09 09 09 66 6f 72 20 70 6b 67 63 68 61 6e 67 65  ...for pkgchange
0980: 20 69 6e 20 22 24 7b 70 6b 67 63 68 61 6e 67 65   in "${pkgchange
0990: 73 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09 09 09 63  s[@]}"; do.....c
09a0: 61 73 65 20 22 24 7b 70 6b 67 63 68 61 6e 67 65  ase "${pkgchange
09b0: 7d 22 20 69 6e 0a 09 09 09 09 09 43 46 4c 41 47  }" in......CFLAG
09c0: 53 29 0a 09 09 09 09 09 09 43 46 4c 41 47 53 3d  S).......CFLAGS=
09d0: 22 24 7b 43 46 4c 41 47 53 7d 20 2d 49 24 7b 70  "${CFLAGS} -I${p
09e0: 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a  kgdir}/include".
09f0: 09 09 09 09 09 09 43 50 50 46 4c 41 47 53 3d 22  ......CPPFLAGS="
0a00: 24 7b 43 50 50 46 4c 41 47 53 7d 20 2d 49 24 7b  ${CPPFLAGS} -I${
0a10: 70 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  pkgdir}/include"
0a20: 0a 09 09 09 09 09 09 65 78 70 6f 72 74 20 43 46  .......export CF
0a30: 4c 41 47 53 20 43 50 50 46 4c 41 47 53 0a 09 09  LAGS CPPFLAGS...
0a40: 09 09 09 09 3b 3b 0a 09 09 09 09 09 4c 44 46 4c  ....;;......LDFL
0a50: 41 47 53 29 0a 09 09 09 09 09 09 4c 44 46 4c 41  AGS).......LDFLA
0a60: 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d  GS="${LDFLAGS} -
0a70: 4c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 20 2d  L${pkgdir}/lib -
0a80: 57 6c 2c 2d 72 70 61 74 68 2c 24 7b 70 6b 67 64  Wl,-rpath,${pkgd
0a90: 69 72 7d 2f 6c 69 62 22 0a 09 09 09 09 09 09 65  ir}/lib".......e
0aa0: 78 70 6f 72 74 20 4c 44 46 4c 41 47 53 0a 09 09  xport LDFLAGS...
0ab0: 09 09 09 09 3b 3b 0a 09 09 09 09 09 50 41 54 48  ....;;......PATH
0ac0: 29 0a 09 09 09 09 09 09 50 41 54 48 3d 22 24 7b  ).......PATH="${
0ad0: 50 41 54 48 7d 3a 24 7b 70 6b 67 64 69 72 7d 2f  PATH}:${pkgdir}/
0ae0: 62 69 6e 22 0a 09 09 09 09 09 09 65 78 70 6f 72  bin".......expor
0af0: 74 20 50 41 54 48 0a 09 09 09 09 09 09 3b 3b 0a  t PATH.......;;.
0b00: 09 09 09 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f  .....PKG_CONFIG_
0b10: 50 41 54 48 29 0a 09 09 09 09 09 09 69 66 20 5b  PATH).......if [
0b20: 20 2d 64 20 22 24 7b 70 6b 67 63 6f 6e 66 69 67   -d "${pkgconfig
0b30: 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  dir}" ]; then...
0b40: 09 09 09 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f  .....PKG_CONFIG_
0b50: 50 41 54 48 3d 22 24 7b 50 4b 47 5f 43 4f 4e 46  PATH="${PKG_CONF
0b60: 49 47 5f 50 41 54 48 7d 3a 24 7b 70 6b 67 63 6f  IG_PATH}:${pkgco
0b70: 6e 66 69 67 64 69 72 7d 22 0a 09 09 09 09 09 09  nfigdir}".......
0b80: 09 65 78 70 6f 72 74 20 50 4b 47 5f 43 4f 4e 46  .export PKG_CONF
0b90: 49 47 5f 50 41 54 48 0a 09 09 09 09 09 09 66 69  IG_PATH.......fi
0ba0: 0a 09 09 09 09 09 09 3b 3b 0a 09 09 09 09 65 73  .......;;.....es
0bb0: 61 63 0a 09 09 09 64 6f 6e 65 0a 09 09 64 6f 6e  ac....done...don
0bc0: 65 0a 0a 09 09 69 66 20 5b 20 22 24 7b 70 6b 67  e....if [ "${pkg
0bd0: 66 6f 75 6e 64 7d 22 20 3d 20 27 30 27 20 5d 3b  found}" = '0' ];
0be0: 20 74 68 65 6e 0a 09 09 09 64 69 65 20 22 50 61   then....die "Pa
0bf0: 63 6b 61 67 65 20 24 7b 70 6b 67 7d 2f 24 7b 70  ckage ${pkg}/${p
0c00: 6b 67 76 65 72 73 69 6f 6e 3a 2d 2a 7d 40 24 7b  kgversion:-*}@${
0c10: 70 6b 67 64 6f 6d 61 69 6e 7d 20 6e 6f 74 20 66  pkgdomain} not f
0c20: 6f 75 6e 64 2e 22 0a 09 09 66 69 0a 09 64 6f 6e  ound."...fi..don
0c30: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
0c40: 72 69 66 79 50 72 65 72 65 71 75 69 73 69 74 65  rifyPrerequisite
0c50: 73 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  s() {..:.}..func
0c60: 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65 4f 73  tion determineOs
0c70: 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d 22 24 28  Arch() {..os="$(
0c80: 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64 20 63 6f  uname -s | dd co
0c90: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0ca0: 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d 22 24 28  null)"..arch="$(
0cb0: 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64 20 63 6f  uname -m | dd co
0cc0: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0cd0: 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65 20 22 24  null)"...case "$
0ce0: 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09 69 3f 38  {arch}" in...i?8
0cf0: 36 29 0a 09 09 09 61 72 63 68 3d 27 69 78 38 36  6)....arch='ix86
0d00: 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 7d 0a  '....;;..esac.}.
0d10: 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d  .function determ
0d20: 69 6e 65 50 72 65 66 69 78 28 29 20 7b 0a 09 64  inePrefix() {..d
0d30: 65 74 65 72 6d 69 6e 65 4f 73 41 72 63 68 0a 0a  etermineOsArch..
0d40: 09 70 72 65 66 69 78 73 75 66 66 69 78 3d 22 24  .prefixsuffix="$
0d50: 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24 7b 61 72  {pkg}/${os}-${ar
0d60: 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e 7d 22 0a  ch}/${version}".
0d70: 09 70 72 65 66 69 78 3d 22 2f 6f 70 74 2f 61 70  .prefix="/opt/ap
0d80: 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d 2f 24 7b  pfs/${domain}/${
0d90: 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 0a 09  prefixsuffix}"..
0da0: 64 65 73 74 64 69 72 3d 22 24 28 70 77 64 29 2f  destdir="$(pwd)/
0db0: 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72 20 22 24  INST"...mkdir "$
0dc0: 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c 20 64 69  {destdir}" || di
0dd0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72  e.}..function pr
0de0: 65 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09  econfigure() {..
0df0: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f  :.}..function po
0e00: 73 74 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  stconfigure() {.
0e10: 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63  .:.}..function c
0e20: 6f 6e 66 69 67 75 72 65 5f 67 63 63 28 29 20 7b  onfigure_gcc() {
0e30: 0a 09 67 6c 69 62 63 64 69 72 3d 22 2f 6f 70 74  ..glibcdir="/opt
0e40: 2f 61 70 70 66 73 2f 63 6f 72 65 2e 61 70 70 66  /appfs/core.appf
0e50: 73 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 67 6c 69  s.rkeene.org/gli
0e60: 62 63 2f 70 6c 61 74 66 6f 72 6d 2f 6c 61 74 65  bc/platform/late
0e70: 73 74 22 0a 09 67 6c 69 62 63 64 69 72 3d 22 24  st"..glibcdir="$
0e80: 28 72 65 61 64 6c 69 6e 6b 20 2d 66 20 22 24 7b  (readlink -f "${
0e90: 67 6c 69 62 63 64 69 72 7d 22 29 22 0a 0a 09 64  glibcdir}")"...d
0ea0: 79 6e 6c 69 6e 6b 65 72 3d 22 24 28 6c 73 20 22  ynlinker="$(ls "
0eb0: 24 7b 67 6c 69 62 63 64 69 72 7d 22 2f 6c 69 62  ${glibcdir}"/lib
0ec0: 2f 6c 64 2d 6c 69 6e 75 78 2a 2e 73 6f 2e 2a 20  /ld-linux*.so.* 
0ed0: 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 0a 09  | tail -n 1)"...
0ee0: 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 64 79 6e  if [ ! -f "${dyn
0ef0: 6c 69 6e 6b 65 72 7d 22 20 5d 3b 20 74 68 65 6e  linker}" ]; then
0f00: 0a 09 09 64 69 65 20 27 67 6c 69 62 63 20 64 69  ...die 'glibc di
0f10: 72 65 63 74 6f 72 79 20 69 73 20 6e 6f 74 20 61  rectory is not a
0f20: 76 61 69 6c 61 62 6c 65 20 28 61 70 70 66 73 20  vailable (appfs 
0f30: 72 75 6e 6e 69 6e 67 2f 77 6f 72 6b 69 6e 67 3f  running/working?
0f40: 29 27 0a 09 66 69 0a 0a 09 43 43 3d 22 24 7b 43  )'..fi...CC="${C
0f50: 43 3a 2d 67 63 63 7d 20 2d 6e 6f 73 74 64 69 6e  C:-gcc} -nostdin
0f60: 63 20 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d 2f  c -I${glibcdir}/
0f70: 69 6e 63 6c 75 64 65 22 0a 09 42 55 49 4c 44 5f  include"..BUILD_
0f80: 43 43 3d 22 24 7b 43 43 7d 22 0a 09 48 4f 53 54  CC="${CC}"..HOST
0f90: 5f 43 43 3d 22 24 7b 43 43 7d 22 0a 09 4c 44 46  _CC="${CC}"..LDF
0fa0: 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d  LAGS="${LDFLAGS}
0fb0: 20 2d 57 6c 2c 2d 2d 72 70 61 74 68 2c 24 7b 67   -Wl,--rpath,${g
0fc0: 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20 2d 57 6c  libcdir}/lib -Wl
0fd0: 2c 2d 2d 64 79 6e 61 6d 69 63 2d 6c 69 6e 6b 65  ,--dynamic-linke
0fe0: 72 2c 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 0a  r,${dynlinker}".
0ff0: 09 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49 42 44  .PKG_CONFIG_LIBD
1000: 49 52 3d 22 24 7b 67 6c 69 62 63 64 69 72 7d 2f  IR="${glibcdir}/
1010: 6c 69 62 2f 70 6b 67 63 6f 6e 66 69 67 22 0a 09  lib/pkgconfig"..
1020: 65 78 70 6f 72 74 20 43 43 20 42 55 49 4c 44 5f  export CC BUILD_
1030: 43 43 20 48 4f 53 54 5f 43 43 20 4c 44 46 4c 41  CC HOST_CC LDFLA
1040: 47 53 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49  GS PKG_CONFIG_LI
1050: 42 44 49 52 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  BDIR.}..function
1060: 20 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09   configure() {..
1070: 63 6f 6e 66 69 67 75 72 65 5f 67 63 63 0a 09 2e  configure_gcc...
1080: 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 70 72 65  /configure --pre
1090: 66 69 78 3d 22 24 7b 70 72 65 66 69 78 7d 22 20  fix="${prefix}" 
10a0: 2d 2d 73 79 73 63 6f 6e 66 64 69 72 3d 22 24 7b  --sysconfdir="${
10b0: 70 72 65 66 69 78 7d 2f 65 74 63 22 20 2d 2d 6c  prefix}/etc" --l
10c0: 69 62 64 69 72 3d 22 24 7b 70 72 65 66 69 78 7d  ibdir="${prefix}
10d0: 2f 6c 69 62 22 20 2d 2d 6c 6f 63 61 6c 73 74 61  /lib" --localsta
10e0: 74 65 64 69 72 3d 2f 76 61 72 20 22 24 7b 63 6f  tedir=/var "${co
10f0: 6e 66 69 67 75 72 65 5f 65 78 74 72 61 5b 40 5d  nfigure_extra[@]
1100: 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70  }".}..function p
1110: 72 65 62 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d  rebuild() {..:.}
1120: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74 62  ..function postb
1130: 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66  uild() {..:.}..f
1140: 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64 28 29 20  unction build() 
1150: 7b 0a 09 67 72 65 70 20 22 44 45 53 54 44 49 52  {..grep "DESTDIR
1160: 22 20 4d 61 6b 65 66 69 6c 65 20 3e 2f 64 65 76  " Makefile >/dev
1170: 2f 6e 75 6c 6c 20 7c 7c 20 64 69 65 20 22 44 6f  /null || die "Do
1180: 6e 27 74 20 6b 6e 6f 77 20 68 6f 77 20 74 6f 20  n't know how to 
1190: 62 75 69 6c 64 20 74 68 69 73 20 73 6f 66 74 77  build this softw
11a0: 61 72 65 22 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a 66  are"...make.}..f
11b0: 75 6e 63 74 69 6f 6e 20 70 72 65 69 6e 73 74 61  unction preinsta
11c0: 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e  ll() {..:.}..fun
11d0: 63 74 69 6f 6e 20 70 6f 73 74 69 6e 73 74 61 6c  ction postinstal
11e0: 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  l() {..:.}..func
11f0: 74 69 6f 6e 20 69 6e 73 74 61 6c 6c 28 29 20 7b  tion install() {
1200: 0a 09 6d 61 6b 65 20 69 6e 73 74 61 6c 6c 20 44  ..make install D
1210: 45 53 54 44 49 52 3d 22 24 7b 64 65 73 74 64 69  ESTDIR="${destdi
1220: 72 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20  r}".}..function 
1230: 63 6c 65 61 6e 75 70 28 29 20 7b 0a 09 63 64 20  cleanup() {..cd 
1240: 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20  "${workdir}" || 
1250: 65 78 69 74 20 31 0a 09 63 64 20 2e 2e 20 7c 7c  exit 1..cd .. ||
1260: 20 65 78 69 74 20 31 0a 09 72 6d 20 2d 72 66 20   exit 1..rm -rf 
1270: 22 24 7b 77 6f 72 6b 64 69 72 7d 22 0a 7d 0a 0a  "${workdir}".}..
1280: 66 75 6e 63 74 69 6f 6e 20 64 69 65 28 29 20 7b  function die() {
1290: 0a 09 6c 6f 63 61 6c 20 6d 65 73 73 61 67 65 0a  ..local message.
12a0: 0a 09 6d 65 73 73 61 67 65 3d 22 24 31 22 0a 0a  ..message="$1"..
12b0: 09 69 66 20 5b 20 2d 6e 20 22 24 7b 6d 65 73 73  .if [ -n "${mess
12c0: 61 67 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  age}" ]; then...
12d0: 65 63 68 6f 20 22 65 72 72 6f 72 3a 20 24 7b 6d  echo "error: ${m
12e0: 65 73 73 61 67 65 7d 22 20 3e 26 32 0a 09 66 69  essage}" >&2..fi
12f0: 0a 0a 09 65 78 69 74 20 31 0a 7d 0a 0a 73 63 72  ...exit 1.}..scr
1300: 69 70 74 64 69 72 3d 22 24 28 63 64 20 22 24 28  iptdir="$(cd "$(
1310: 64 69 72 6e 61 6d 65 20 22 24 28 77 68 69 63 68  dirname "$(which
1320: 20 22 24 30 22 29 22 29 22 20 26 26 20 70 77 64   "$0")")" && pwd
1330: 29 22 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 73 63  )".if [ -z "${sc
1340: 72 69 70 74 64 69 72 7d 22 20 5d 3b 20 74 68 65  riptdir}" ]; the
1350: 6e 0a 09 65 63 68 6f 20 22 55 6e 61 62 6c 65 20  n..echo "Unable 
1360: 74 6f 20 6c 6f 63 61 74 65 20 73 63 72 69 70 74  to locate script
1370: 20 64 69 72 65 63 74 6f 72 79 22 20 3e 26 32 0a   directory" >&2.
1380: 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 63 64 20  ..exit 1.fi..cd 
1390: 22 24 7b 73 63 72 69 70 74 64 69 72 7d 22 20 7c  "${scriptdir}" |
13a0: 7c 20 65 78 69 74 20 31 0a 0a 69 66 20 5b 20 2d  | exit 1..if [ -
13b0: 66 20 27 62 75 69 6c 64 2e 63 6f 6e 66 27 20 5d  f 'build.conf' ]
13c0: 3b 20 74 68 65 6e 0a 09 2e 20 27 62 75 69 6c 64  ; then... 'build
13d0: 2e 63 6f 6e 66 27 0a 66 69 0a 0a 69 66 20 5b 20  .conf'.fi..if [ 
13e0: 2d 64 20 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22  -d "pkgs/${pkg}"
13f0: 20 5d 3b 20 74 68 65 6e 0a 09 70 6b 67 64 69 72   ]; then..pkgdir
1400: 3d 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09  ="pkgs/${pkg}"..
1410: 70 6b 67 66 69 6c 65 3d 22 24 7b 70 6b 67 64 69  pkgfile="${pkgdi
1420: 72 7d 2f 69 6e 66 6f 22 0a 65 6c 73 65 0a 09 70  r}/info".else..p
1430: 6b 67 66 69 6c 65 3d 22 70 6b 67 73 2f 24 7b 70  kgfile="pkgs/${p
1440: 6b 67 7d 22 0a 09 70 6b 67 64 69 72 3d 22 24 7b  kg}"..pkgdir="${
1450: 70 6b 67 66 69 6c 65 7d 22 0a 66 69 0a 0a 69 66  pkgfile}".fi..if
1460: 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67 66 69   [ ! -e "${pkgfi
1470: 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63  le}" ]; then..ec
1480: 68 6f 20 22 49 6e 76 61 6c 69 64 20 70 61 63 6b  ho "Invalid pack
1490: 61 67 65 2e 22 20 3e 26 32 0a 0a 09 65 78 69 74  age." >&2...exit
14a0: 20 31 0a 66 69 0a 0a 70 6b 67 64 61 74 65 3d 22   1.fi..pkgdate="
14b0: 24 28 66 6f 72 20 61 72 74 69 66 61 63 74 20 69  $(for artifact i
14c0: 6e 20 24 28 66 69 6e 64 20 22 24 7b 70 6b 67 64  n $(find "${pkgd
14d0: 69 72 7d 22 20 2d 74 79 70 65 20 66 20 2d 70 72  ir}" -type f -pr
14e0: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 6e 20  int0 | xargs -n 
14f0: 31 20 2d 30 20 66 6f 73 73 69 6c 20 66 69 6e 66  1 -0 fossil finf
1500: 6f 20 2d 2d 6c 69 6d 69 74 20 31 20 2d 2d 77 69  o --limit 1 --wi
1510: 64 74 68 20 30 20 32 3e 2f 64 65 76 2f 6e 75 6c  dth 0 2>/dev/nul
1520: 6c 20 7c 20 67 72 65 70 20 27 5e 5b 30 2d 39 5d  l | grep '^[0-9]
1530: 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d  [0-9][0-9][0-9]-
1540: 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d  [0-9][0-9]-[0-9]
1550: 5b 30 2d 39 5d 20 27 20 7c 20 73 65 64 20 27 73  [0-9] ' | sed 's
1560: 40 5e 5b 5e 20 5d 2a 20 5c 5b 40 40 3b 73 40 5c  @^[^ ]* \[@@;s@\
1570: 5d 2e 2a 40 40 27 20 7c 20 73 6f 72 74 20 2d 75  ].*@@' | sort -u
1580: 29 3b 20 64 6f 20 66 6f 73 73 69 6c 20 69 6e 66  ); do fossil inf
1590: 6f 20 22 24 7b 61 72 74 69 66 61 63 74 7d 22 20  o "${artifact}" 
15a0: 7c 20 61 77 6b 20 27 2f 5e 75 75 69 64 3a 2f 7b  | awk '/^uuid:/{
15b0: 20 70 72 69 6e 74 20 24 33 20 24 34 20 7d 27 20   print $3 $4 }' 
15c0: 7c 20 73 65 64 20 27 73 40 5b 2d 3a 5d 40 40 67  | sed 's@[-:]@@g
15d0: 3b 73 40 2e 2e 24 40 5c 2e 26 40 27 3b 20 64 6f  ;s@..$@\.&@'; do
15e0: 6e 65 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74  ne | sort -n | t
15f0: 61 69 6c 20 2d 6e 20 31 29 22 0a 69 66 20 5b 20  ail -n 1)".if [ 
1600: 2d 7a 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20  -z "${pkgdate}" 
1610: 5d 3b 20 74 68 65 6e 0a 09 70 6b 67 64 61 74 65  ]; then..pkgdate
1620: 3d 22 24 28 66 69 6e 64 20 22 24 7b 70 6b 67 64  ="$(find "${pkgd
1630: 69 72 7d 22 20 2d 74 79 70 65 20 66 20 2d 70 72  ir}" -type f -pr
1640: 69 6e 74 66 20 27 25 54 59 25 54 6d 25 54 64 25  intf '%TY%Tm%Td%
1650: 54 48 25 54 4d 2e 25 54 53 5c 6e 27 20 32 3e 2f  TH%TM.%TS\n' 2>/
1660: 64 65 76 2f 6e 75 6c 6c 20 7c 20 63 75 74 20 2d  dev/null | cut -
1670: 66 20 31 2d 32 20 2d 64 20 27 2e 27 20 7c 20 73  f 1-2 -d '.' | s
1680: 6f 72 74 20 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e  ort -n | tail -n
1690: 20 31 29 22 0a 66 69 0a 0a 2e 20 22 24 7b 70 6b   1)".fi... "${pk
16a0: 67 66 69 6c 65 7d 22 0a 0a 61 72 63 68 69 76 65  gfile}"..archive
16b0: 64 69 72 3d 22 24 28 70 77 64 29 2f 41 52 43 48  dir="$(pwd)/ARCH
16c0: 49 56 45 22 0a 77 6f 72 6b 64 69 72 3d 22 77 6f  IVE".workdir="wo
16d0: 72 6b 64 69 72 2d 24 24 24 7b 52 41 4e 44 4f 4d  rkdir-$$${RANDOM
16e0: 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44  }${RANDOM}${RAND
16f0: 4f 4d 7d 22 0a 70 6b 67 61 72 63 68 69 76 65 3d  OM}".pkgarchive=
1700: 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f 24  "${archivedir}/$
1710: 7b 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d  {pkg}-${version}
1720: 22 0a 6d 6b 64 69 72 20 22 24 7b 61 72 63 68 69  ".mkdir "${archi
1730: 76 65 64 69 72 7d 22 20 3e 2f 64 65 76 2f 6e 75  vedir}" >/dev/nu
1740: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 6d  ll 2>/dev/null.m
1750: 6b 64 69 72 20 22 24 7b 77 6f 72 6b 64 69 72 7d  kdir "${workdir}
1760: 22 20 7c 7c 20 65 78 69 74 20 31 0a 63 64 20 22  " || exit 1.cd "
1770: 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65  ${workdir}" || e
1780: 78 69 74 20 31 0a 77 6f 72 6b 64 69 72 3d 22 24  xit 1.workdir="$
1790: 28 70 77 64 29 22 0a 0a 23 20 44 6f 77 6e 6c 6f  (pwd)"..# Downlo
17a0: 61 64 0a 64 6f 77 6e 6c 6f 61 64 0a 0a 23 20 45  ad.download..# E
17b0: 78 74 72 61 63 74 0a 65 78 74 72 61 63 74 0a 0a  xtract.extract..
17c0: 23 20 49 66 20 77 65 20 6a 75 73 74 20 68 61 76  # If we just hav
17d0: 65 20 6f 6e 65 20 64 69 72 65 63 74 6f 72 79 2c  e one directory,
17e0: 20 75 73 65 20 74 68 61 74 20 64 69 72 65 63 74   use that direct
17f0: 6f 72 79 0a 64 69 72 3d 22 24 28 65 63 68 6f 20  ory.dir="$(echo 
1800: 2a 29 22 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64  *)".if [ -e "${d
1810: 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76  ir}" ]; then..mv
1820: 20 22 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69   "${dir}"/* ..fi
1830: 0a 0a 23 20 56 65 72 69 66 79 20 70 72 65 2d 72  ..# Verify pre-r
1840: 65 71 75 69 73 69 74 65 73 20 61 72 65 20 6d 65  equisites are me
1850: 74 0a 76 65 72 69 66 79 52 65 71 75 69 72 65 64  t.verifyRequired
1860: 50 61 63 6b 61 67 65 73 20 7c 7c 20 64 69 65 20  Packages || die 
1870: 27 52 65 71 75 69 72 65 64 20 70 61 63 6b 61 67  'Required packag
1880: 65 73 20 6d 69 73 73 69 6e 67 27 0a 76 65 72 69  es missing'.veri
1890: 66 79 50 72 65 72 65 71 75 69 73 69 74 65 73 20  fyPrerequisites 
18a0: 7c 7c 20 64 69 65 20 27 50 72 65 72 65 71 75 69  || die 'Prerequi
18b0: 73 69 74 69 65 73 20 66 61 69 6c 65 64 27 0a 0a  sities failed'..
18c0: 23 20 53 74 61 72 74 20 6c 6f 67 67 69 6e 67 0a  # Start logging.
18d0: 73 65 74 20 2d 78 0a 0a 23 20 44 65 74 65 72 6d  set -x..# Determ
18e0: 69 6e 65 20 70 72 6f 70 65 72 74 69 65 73 0a 64  ine properties.d
18f0: 65 74 65 72 6d 69 6e 65 50 72 65 66 69 78 0a 0a  eterminePrefix..
1900: 23 20 53 74 61 72 74 20 74 68 65 20 62 75 69 6c  # Start the buil
1910: 64 0a 70 72 65 63 6f 6e 66 69 67 75 72 65 20 7c  d.preconfigure |
1920: 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66 69 67  | die 'preconfig
1930: 75 72 65 20 66 61 69 6c 65 64 27 0a 63 6f 6e 66  ure failed'.conf
1940: 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 63 6f  igure || die 'co
1950: 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a  nfigure failed'.
1960: 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c  postconfigure ||
1970: 20 64 69 65 20 27 70 6f 73 74 63 6f 6e 66 69 67   die 'postconfig
1980: 75 72 65 20 66 61 69 6c 65 64 27 0a 0a 70 72 65  ure failed'..pre
1990: 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 72  build || die 'pr
19a0: 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 62  ebuild failed'.b
19b0: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 62 75 69  uild || die 'bui
19c0: 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 62  ld failed'.postb
19d0: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 6f 73  uild || die 'pos
19e0: 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a  tbuild failed'..
19f0: 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  preinstall || di
1a00: 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66 61  e 'preinstall fa
1a10: 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20 7c 7c  iled'.install ||
1a20: 20 64 69 65 20 27 69 6e 73 74 61 6c 6c 20 66 61   die 'install fa
1a30: 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74 61 6c  iled'.postinstal
1a40: 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 69 6e  l || die 'postin
1a50: 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 28  stall failed'..(
1a60: 0a 09 63 61 73 65 20 22 24 7b 74 61 72 67 65 74  ..case "${target
1a70: 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69 6e 73 74  mode}" in...inst
1a80: 61 6c 6c 29 0a 09 09 09 61 70 70 64 69 72 3d 22  all)....appdir="
1a90: 24 28 61 70 70 66 73 69 6e 73 74 61 6c 6c 64 69  $(appfsinstalldi
1aa0: 72 29 2f 24 7b 70 72 65 66 69 78 73 75 66 66 69  r)/${prefixsuffi
1ab0: 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20 2d 70 20  x}"....mkdir -p 
1ac0: 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09 09 09  "${appdir}".....
1ad0: 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d 2f 24  cd "${destdir}/$
1ae0: 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20 65 78 69  {prefix}" || exi
1af0: 74 20 31 0a 0a 09 09 09 63 70 20 2d 72 70 20 2a  t 1.....cp -rp *
1b00: 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 09 09 09   "${appdir}"....
1b10: 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22  find "${appdir}"
1b20: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
1b30: 20 2d 30 20 74 6f 75 63 68 20 2d 74 20 22 24 7b   -0 touch -t "${
1b40: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e  pkgdate}"....fin
1b50: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
1b60: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
1b70: 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b   touch -m -t "${
1b80: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e  pkgdate}"....fin
1b90: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
1ba0: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
1bb0: 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22 24 7b   touch -a -t "${
1bc0: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 3b 3b 0a  pkgdate}"....;;.
1bd0: 09 09 61 72 63 68 69 76 65 29 0a 09 09 09 61 72  ..archive)....ar
1be0: 63 68 69 76 65 66 69 6c 65 3d 22 24 7b 73 63 72  chivefile="${scr
1bf0: 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67 7d 2d 24  iptdir}/${pkg}-$
1c00: 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65 63 68 6f  {version}-$(echo
1c10: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 7c 20   "${pkgdate}" | 
1c20: 73 65 64 20 27 73 40 5c 2e 40 40 67 27 29 2d 24  sed 's@\.@@g')-$
1c30: 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d 2d 24 7b 64  {os}-${arch}-${d
1c40: 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a 09 09 09  omain}.cpio"....
1c50: 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d 2f 24  cd "${destdir}/$
1c60: 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e 2e 2f 2e  {prefix}/../../.
1c70: 2e 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 09  ." || exit 1....
1c80: 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73 75  find "${prefixsu
1c90: 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c  ffix}" -print0 |
1ca0: 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20   xargs -0 touch 
1cb0: 2d 74 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a  -t "${pkgdate}".
1cc0: 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69  ...find "${prefi
1cd0: 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74  xsuffix}" -print
1ce0: 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75  0 | xargs -0 tou
1cf0: 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b 67 64  ch -m -t "${pkgd
1d00: 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22 24  ate}"....find "$
1d10: 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 20  {prefixsuffix}" 
1d20: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
1d30: 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22  -0 touch -a -t "
1d40: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
1d50: 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73 75 66  ind "${prefixsuf
1d60: 66 69 78 7d 22 20 7c 20 73 6f 72 74 20 7c 20 63  fix}" | sort | c
1d70: 70 69 6f 20 2d 2d 6f 77 6e 65 72 20 30 3a 30 20  pio --owner 0:0 
1d80: 2d 48 20 6e 65 77 63 20 2d 6f 20 3e 20 22 24 7b  -H newc -o > "${
1d90: 61 72 63 68 69 76 65 66 69 6c 65 7d 22 0a 09 09  archivefile}"...
1da0: 09 3b 3b 0a 09 65 73 61 63 0a 29 20 7c 7c 20 64  .;;..esac.) || d
1db0: 69 65 20 27 66 69 6e 61 6c 20 69 6e 73 74 61 6c  ie 'final instal
1dc0: 6c 61 74 69 6f 6e 20 66 61 69 6c 65 64 27 0a 0a  lation failed'..
1dd0: 63 6c 65 61 6e 75 70 0a 0a 65 78 69 74 20 30 0a  cleanup..exit 0.